/*  Botik::Key Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __MANAGER_H__
#define __MANAGER_H__

#include "resource.h"

// Global variables.
extern HINSTANCE	g_hInst;			// Current instance
extern HICON		g_hBigIcon;
extern HICON		g_hSmallIcon;
extern INT			g_nCurAccess;
extern INT			g_nReqAccess;
extern HKEY			g_hKeyCurUsr;
extern HKEY			g_hKeyLocMch;
extern HKEY			g_hKeyAS;
extern BOOL			g_fIsWinNT;			// Shows NT or 9x platform
extern BOOL			g_fIs2K;			// Shows that the system is >= Win2K
extern DWORD		g_dwSP;				// Latest installed SP version number
extern BOOL			g_fBlnEnbl;			// Shows is balloon tips enabled
extern DWORD		g_dwSvcStatus;
extern TCHAR		g_szChmPath[];
extern INT			g_nLastNewVer;
extern BOOL			g_fSysParamsRO;		// Sys params (service config and etc) are read only.

extern INT			g_nStartupMode;
extern BOOL			g_fHideMin;
extern BOOL			g_fHideClose;
extern BOOL			g_fOneClick;
extern BOOL			g_fForceLogviewer;
extern BOOL			g_fAsterisks;
extern INT			g_nSwitchClose;
extern INT			g_nSwitchStart;
extern INT			g_nSvcSwitchStart;
extern BOOL			g_fWriteLogFile;
extern BOOL			g_fInformMngr;
extern INT			g_nPasswdPlace;
extern LPTSTR		g_szPasswdFile;
extern LPTSTR		g_szPasswd;
extern BOOL			g_fUseStdPort;
extern BOOL			g_fUseGWAddr;
extern LONG			g_nPortNumber;
extern LPTSTR		g_szSrvAddress;
extern BOOL			g_fSvcConfChanged;
extern BOOL			g_fMgrConfChanged;

// Startup modes.
#define ABK_MNGR_STARTUP_NORMAL		0x0000
#define ABK_MNGR_STARTUP_MIN		0x0001
#define ABK_MNGR_STARTUP_HIDE		0x0002

// Tray notification icon ID.
#define ABK_MNGR_NOTIFY_ICON_ID	0x0001

// User defined message IDs.
#define WM_USER_NOTIFYICON				WM_USER+1	// Send from tray notification icon.
#define WM_USER_KILL_MANAGER			WM_USER+2	// Service tell to kill manager.
#define WM_USER_SVC_CONNECTED			WM_USER+3	// Service connected.
#define WM_USER_SVC_STOPPED				WM_USER+4	// Service stopped.
#define WM_USER_PROMPT_PASSWORD			WM_USER+5	// Service asks user to enter password.
#define WM_USER_NEW_EVENT				WM_USER+6	// Service have a new event in the event log.

// Check for updates.
#ifndef _DEBUG
//  #define BKP_UPDATE_URL			_T("http://joker.u.pereslavl.ru/~alexvm/projects/bkp/download/version.txt")
  #define BKP_UPDATE_URL			_T("http://www.botik.ru/~botik-key-pro/download/version.txt")
#else
  #define BKP_UPDATE_URL			_T("http://localhost/~bkp/download/version.txt")
#endif

#define BKP_UPDATE_BUFF_SIZE		256
#define BKP_UPDATE_TIMER_ID			1
#define BKP_UPDATE_TIMER_ELAPSE		4*60*60*1000	// 4 hours
#define BKP_UPDATE_PREFIX			"Current version:" // New format
//#define BKP_UPDATE_PREFIX			"BKP-UPDATE:"

// Functions...
BOOL SetAccessMode(INT nMode_);
VOID RunPwd2KeyUtil(VOID);
BOOL DoStartupService(VOID);
BOOL DoShutdownService(VOID);

#endif // __MANAGER_H__

