/*  Botik::Key Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "stdafx.h"
#include "logviewer.h"
#include "main_dlg.h"
#include "opt_tab_mngr_dlg.h"

HWND g_hMngrTabDlg;

HWND CreateManagerTab(HWND hPrnWnd_)
{
	g_hMngrTabDlg = CreateDialog(g_hInst, MAKEINTRESOURCE(IDD_OPT_TAB_MNGR), 
							hPrnWnd_, (DLGPROC)WndProcMT);
	return(g_hMngrTabDlg);
};

LRESULT CALLBACK WndProcMT(HWND hWnd_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_)
{
	PAINTSTRUCT ps;
	HDC hdc;

	switch (uMsg_) 
	{
	case WM_INITDIALOG:
		return OnInitDialogMT(hWnd_, wParam_, lParam_);

	case WM_COMMAND:
		OnCommandMT(hWnd_, wParam_, lParam_);
		break;

	case WM_PAINT:
		hdc = BeginPaint(hWnd_, &ps);
		EndPaint(hWnd_, &ps);
		break;
	};

	return FALSE;
};

LRESULT OnInitDialogMT(HWND hWnd_, WPARAM wParam_, LPARAM lParam_)
{
	TCHAR szBuf[MAX_LOADSTRING];

	// Start state combobox.
	LoadString(g_hInst, IDS_STRING107, szBuf, MAX_LOADSTRING-1);
	SendDlgItemMessage(hWnd_, IDC_START_SWITCH, CB_INSERTSTRING, 0, (LPARAM)szBuf);
	SendDlgItemMessage(hWnd_, IDC_START_SWITCH, CB_SETITEMDATA, 0, ABK_ACCESS_LEAVE);

	LoadString(g_hInst, IDS_STRING108, szBuf, MAX_LOADSTRING-1);
	SendDlgItemMessage(hWnd_, IDC_START_SWITCH, CB_INSERTSTRING, 1, (LPARAM)szBuf);
	SendDlgItemMessage(hWnd_, IDC_START_SWITCH, CB_SETITEMDATA, 1, ABK_ACCESS_NONE);

	LoadString(g_hInst, IDS_STRING110, szBuf, MAX_LOADSTRING-1);
	SendDlgItemMessage(hWnd_, IDC_START_SWITCH, CB_INSERTSTRING, 2, (LPARAM)szBuf);
	SendDlgItemMessage(hWnd_, IDC_START_SWITCH, CB_SETITEMDATA, 2, ABK_ACCESS_LOCAL);

	LoadString(g_hInst, IDS_STRING111, szBuf, MAX_LOADSTRING-1);
	SendDlgItemMessage(hWnd_, IDC_START_SWITCH, CB_INSERTSTRING, 3, (LPARAM)szBuf);
	SendDlgItemMessage(hWnd_, IDC_START_SWITCH, CB_SETITEMDATA, 3, ABK_ACCESS_WORLD);	
	
	// Finish state combobox.
	LoadString(g_hInst, IDS_STRING107, szBuf, MAX_LOADSTRING-1);
	SendDlgItemMessage(hWnd_, IDC_CLOSE_SWITCH, CB_INSERTSTRING, 0, (LPARAM)szBuf);
	SendDlgItemMessage(hWnd_, IDC_CLOSE_SWITCH, CB_SETITEMDATA, 0, ABK_ACCESS_LEAVE);

	LoadString(g_hInst, IDS_STRING108, szBuf, MAX_LOADSTRING-1);
	SendDlgItemMessage(hWnd_, IDC_CLOSE_SWITCH, CB_INSERTSTRING, 1, (LPARAM)szBuf);
	SendDlgItemMessage(hWnd_, IDC_CLOSE_SWITCH, CB_SETITEMDATA, 1, ABK_ACCESS_NONE);

	LoadString(g_hInst, IDS_STRING110, szBuf, MAX_LOADSTRING-1);
	SendDlgItemMessage(hWnd_, IDC_CLOSE_SWITCH, CB_INSERTSTRING, 2, (LPARAM)szBuf);
	SendDlgItemMessage(hWnd_, IDC_CLOSE_SWITCH, CB_SETITEMDATA, 2, ABK_ACCESS_LOCAL);

	LoadString(g_hInst, IDS_STRING111, szBuf, MAX_LOADSTRING-1);
	SendDlgItemMessage(hWnd_, IDC_CLOSE_SWITCH, CB_INSERTSTRING, 3, (LPARAM)szBuf);
	SendDlgItemMessage(hWnd_, IDC_CLOSE_SWITCH, CB_SETITEMDATA, 3, ABK_ACCESS_WORLD);

	UpdateGUIMT(hWnd_);

	return(TRUE);
};

VOID UpdateGUIMT(HWND hWnd_)
{
	LONG lRet;
	INT nCurSel = 0;

	if(g_nSwitchStart == ABK_ACCESS_NONE)
		nCurSel = 1;
	else if(g_nSwitchStart == ABK_ACCESS_LOCAL)
		nCurSel = 2;
	else if(g_nSwitchStart == ABK_ACCESS_WORLD)
		nCurSel = 3;

	SendDlgItemMessage(hWnd_, IDC_START_SWITCH, CB_SETCURSEL, nCurSel, 0);

	nCurSel = 0;

	if(g_nSwitchClose == ABK_ACCESS_NONE)
		nCurSel = 1;
	else if(g_nSwitchClose == ABK_ACCESS_LOCAL)
		nCurSel = 2;
	else if(g_nSwitchClose == ABK_ACCESS_WORLD)
		nCurSel = 3;

	SendDlgItemMessage(hWnd_, IDC_CLOSE_SWITCH, CB_SETCURSEL, nCurSel, 0);

	// Manager startup state.
	if(g_nStartupMode == ABK_MNGR_STARTUP_NORMAL)
		SendDlgItemMessage(hWnd_, IDC_STARTUP_RADIO1, BM_CLICK, 1, 0);
	else if(g_nStartupMode == ABK_MNGR_STARTUP_MIN)
		SendDlgItemMessage(hWnd_, IDC_STARTUP_RADIO2, BM_CLICK, 1, 0);
	else if(g_nStartupMode == ABK_MNGR_STARTUP_HIDE)
		SendDlgItemMessage(hWnd_, IDC_STARTUP_RADIO3, BM_CLICK, 1, 0);

	SendDlgItemMessage(hWnd_, IDC_HIDE_MIN_CHECK,   BM_SETCHECK, g_fHideMin, 0);
	SendDlgItemMessage(hWnd_, IDC_HIDE_CLOSE_CHECK, BM_SETCHECK, g_fHideClose, 0);
	SendDlgItemMessage(hWnd_, IDC_ONE_CLICK_CHECK,  BM_SETCHECK, g_fOneClick, 0);
	SendDlgItemMessage(hWnd_, IDC_FORCE_LOGVIEWER,  BM_SETCHECK, g_fForceLogviewer, 0);
	SendDlgItemMessage(hWnd_, IDC_PLAYSOUND,        BM_SETCHECK, g_fPlaySound, 0);

	// Check if manager autostarts at user logon.
	lRet = cfRegReadSTRVal(g_hKeyAS, REG_MNGR_AUTOSTART_VAL, NULL, NULL);
	SendDlgItemMessage(hWnd_, IDC_LOAD_AT_STARTUP,  BM_SETCHECK, !lRet, 0);

	SetDlgItemInt(hWnd_, IDC_LOG_CNT, g_dwMaxEventsShow, FALSE);
};

LRESULT OnCommandMT(HWND hWnd_, WPARAM wParam_, LPARAM lParam_)
{
	switch(HIWORD(wParam_))
	{
	case BN_CLICKED:
	case CBN_SELCHANGE:
	case EN_CHANGE:
		cfEnableDlgItem(g_hMainDlg, IDAPPLAY, TRUE);
		break;
	};
	return 0;
};


