/*  Botik::Key Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "stdafx.h"
#include "opt_tab_svc_dlg.h"
#include "main_dlg.h"

HWND g_hSvcTabDlg;

HWND CreateSvcTab(HWND hPrnWnd_)
{
	g_hSvcTabDlg = CreateDialog(g_hInst, MAKEINTRESOURCE(IDD_OPT_TAB_SVC), 
								hPrnWnd_, (DLGPROC)WndProcST);
	return(g_hSvcTabDlg);
};

LRESULT CALLBACK WndProcST(HWND hWnd_, UINT uMsg_, WPARAM wParam_, LPARAM lParam_)
{
	PAINTSTRUCT ps;
	HDC hdc;

	switch (uMsg_) 
	{
	case WM_INITDIALOG:
		return OnInitDialogST(hWnd_, wParam_, lParam_);

	case WM_COMMAND:
		OnCommandST(hWnd_, wParam_, lParam_);
		break;

	case WM_PAINT:
		hdc = BeginPaint(hWnd_, &ps);
		EndPaint(hWnd_, &ps);
		break;
	};

	return FALSE;
};

LRESULT OnInitDialogST(HWND hWnd_, WPARAM wParam_, LPARAM lParam_)
{
	TCHAR szBuf[MAX_LOADSTRING];

	SendDlgItemMessage(hWnd_, IDC_BKEYSRV_PORT, EM_SETLIMITTEXT, 5, 0);

	LoadString(g_hInst, IDS_STRING107, szBuf, MAX_LOADSTRING-1);
	SendDlgItemMessage(hWnd_, IDC_SVC_START_SWITCH, CB_INSERTSTRING, 0, (LPARAM)szBuf);
	SendDlgItemMessage(hWnd_, IDC_SVC_START_SWITCH, CB_SETITEMDATA, 0, ABK_ACCESS_LEAVE);

	LoadString(g_hInst, IDS_STRING108, szBuf, MAX_LOADSTRING-1);
	SendDlgItemMessage(hWnd_, IDC_SVC_START_SWITCH, CB_INSERTSTRING, 1, (LPARAM)szBuf);
	SendDlgItemMessage(hWnd_, IDC_SVC_START_SWITCH, CB_SETITEMDATA, 1, ABK_ACCESS_NONE);

	LoadString(g_hInst, IDS_STRING110, szBuf, MAX_LOADSTRING-1);
	SendDlgItemMessage(hWnd_, IDC_SVC_START_SWITCH, CB_INSERTSTRING, 2, (LPARAM)szBuf);
	SendDlgItemMessage(hWnd_, IDC_SVC_START_SWITCH, CB_SETITEMDATA, 2, ABK_ACCESS_LOCAL);

	LoadString(g_hInst, IDS_STRING111, szBuf, MAX_LOADSTRING-1);
	SendDlgItemMessage(hWnd_, IDC_SVC_START_SWITCH, CB_INSERTSTRING, 3, (LPARAM)szBuf);
	SendDlgItemMessage(hWnd_, IDC_SVC_START_SWITCH, CB_SETITEMDATA, 3, ABK_ACCESS_WORLD);

	UpdateGUIST(hWnd_);

	return TRUE;
};

VOID UpdateGUIST(HWND hWnd_)
{
	INT nCurSel = 0;
	
	SendDlgItemMessage(hWnd_, IDC_USE_STD_PORT_CHECK, BM_SETCHECK, g_fUseStdPort, 0);
	SendDlgItemMessage(hWnd_, IDC_USE_GATEWAY_CHECK, BM_SETCHECK, g_fUseGWAddr, 0);
	SendDlgItemMessage(hWnd_, IDC_WRITE_FILE, BM_SETCHECK, g_fWriteLogFile, 0);
	SendDlgItemMessage(hWnd_, IDC_INFORM_MNGR, BM_SETCHECK, g_fInformMngr, 0);

	if(g_fUseStdPort)
		cfEnableDlgItem(hWnd_, IDC_BKEYSRV_PORT, FALSE);

	if(g_fUseGWAddr)
		cfEnableDlgItem(hWnd_, IDC_BKEYSRV_ADDR, FALSE);

	SendDlgItemMessage(hWnd_, IDC_BKEYSRV_PORT, EM_SETLIMITTEXT, 5, 0);

	SetDlgItemInt(hWnd_, IDC_BKEYSRV_PORT, g_nPortNumber, FALSE);
	SetDlgItemText(hWnd_, IDC_BKEYSRV_ADDR, g_szSrvAddress);

	if(g_nSvcSwitchStart == ABK_ACCESS_NONE)
		nCurSel = 1;
	else if(g_nSvcSwitchStart == ABK_ACCESS_LOCAL)
		nCurSel = 2;
	else if(g_nSvcSwitchStart == ABK_ACCESS_WORLD)
		nCurSel = 3;

	SendDlgItemMessage(hWnd_, IDC_SVC_START_SWITCH, CB_SETCURSEL, nCurSel, 0);

	// If user doesn't have priveleged access, just show params.
	if(g_fSysParamsRO)
	{
		cfEnableDlgItem(hWnd_, IDC_USE_STD_PORT_CHECK, FALSE);
		cfEnableDlgItem(hWnd_, IDC_USE_GATEWAY_CHECK, FALSE);
		cfEnableDlgItem(hWnd_, IDC_WRITE_FILE, FALSE);
		cfEnableDlgItem(hWnd_, IDC_INFORM_MNGR, FALSE);
		cfEnableDlgItem(hWnd_, IDC_BKEYSRV_PORT, FALSE);
		cfEnableDlgItem(hWnd_, IDC_BKEYSRV_ADDR, FALSE);
		cfEnableDlgItem(hWnd_, IDC_SVC_START_SWITCH, FALSE);
	};
};

LRESULT OnCommandST(HWND hWnd_, WPARAM wParam_, LPARAM lParam_)
{
	BOOL fState;

	switch(HIWORD(wParam_))
	{
	case BN_CLICKED:
		switch(LOWORD(wParam_))
		{
		case IDC_USE_STD_PORT_CHECK:
			fState = (BOOL)SendDlgItemMessage(hWnd_, IDC_USE_STD_PORT_CHECK, BM_GETCHECK, 0, 0);
			cfEnableDlgItem(hWnd_, IDC_BKEYSRV_PORT, !fState);
			break;

		case IDC_USE_GATEWAY_CHECK:
			fState = (BOOL)SendDlgItemMessage(hWnd_, IDC_USE_GATEWAY_CHECK, BM_GETCHECK, 0, 0);
			cfEnableDlgItem(hWnd_, IDC_BKEYSRV_ADDR, !fState);
			break;
		};

		g_fSvcConfChanged = TRUE;
		break;

	case EN_CHANGE:
	case CBN_SELCHANGE:
		g_fSvcConfChanged = TRUE;
		break;
	};

	if(g_fSvcConfChanged)
		cfEnableDlgItem(g_hMainDlg, IDAPPLAY, TRUE);

	return(0);
};
