/*  Botik::Key Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "stdafx.h"
#include "main_dlg.h"
#include "logviewer.h"
#include "interface_h.h"
#include "notify_icon.h"
#include "message_dispatcher.h"
#include "opt_tab_access_dlg.h"

void MngrCurrentAccessMode(unsigned int nMode_, unsigned int nReqMode_)
{
	g_nCurAccess = nMode_;
    g_nReqAccess = nReqMode_;
    cfdprintf("MngrCurrentAccessMode: g_nCurAccess: %d; g_nReqAccess: %d", g_nCurAccess, g_nReqAccess);
	DisplayCurrentAccessMode(g_hAccTabDlg);
};

void MngrServiceStatus(unsigned int nStatus_)
{
	cfdprintf("MngrServiceStatus called: 0x%x", nStatus_);

	if(((g_dwSvcStatus & ABK_SVC_REASON_MASK) != (nStatus_ & ABK_SVC_REASON_MASK)) && g_fIs2K)
	{
		LPTSTR szMsg = _T("");

		// XXX
		if((nStatus_ & ABK_SVC_REASON_MASK) == ABK_SVC_CONNECT_FAILED)
			szMsg = _T("    Key-.");

		ShowBalloonNotifyIcon(g_hMainDlg, ABK_MNGR_NOTIFY_ICON_ID, NIIF_ERROR, ABK_MANAGER_NAME, szMsg);
	};

	g_dwSvcStatus = nStatus_;
	DisplayCurrentServiceStatus(g_hAccTabDlg);
};

void MngrNewEvent(/*unsigned int ulEvtType_, SYSTEMTIME stTime_, unsigned char* szMsgText_*/)
{
	//cfdprintf(_T("MngrNewEvent: %d - %d:%d:%d - %s"), ulEvtType_, stTime_.wHour, stTime_.wMinute, stTime_.wSecond, szMsgText_);

	// XXX UNICODE uncompatible!
	//AddListViewLineLV(ulEvtType_, &stTime_, (LPTSTR)szMsgText_);

	PostMessage(g_hwndLogViewer, WM_USER_NEW_EVENT, 0, 0/*(LRESULT)ulEvtType_*/);
};

void MngrServiceConnected(unsigned int nNeedPwd_)
{
	g_fMngrConnected = TRUE;
	//SendMessage(g_hMainDlg, WM_USER_SVC_CONNECTED, 0, (LPARAM)nNeedPwd_);
	PostMessage(g_hMainDlg, WM_USER_SVC_CONNECTED, 0, (LPARAM)nNeedPwd_);

	// Get Service status.
	g_dwSvcStatus = SvcGetServiceStatus();
	DisplayCurrentServiceStatus(g_hAccTabDlg);

	// Get current service access mode.
	SvcGetAccessMode((UINT*)&g_nCurAccess, (UINT*)&g_nReqAccess);
	DisplayCurrentAccessMode(g_hAccTabDlg);

	// If user wants to change access mode when manager starts, 
	// it is a proper place do do it.
	if(g_nSwitchStart > ABK_ACCESS_LEAVE)
		SetAccessMode(g_nSwitchStart);
};

void MngrPromptPassword()
{
	//SendMessage(g_hMainDlg, WM_USER_PROMPT_PASSWORD, 0, 0);
	PostMessage(g_hMainDlg, WM_USER_PROMPT_PASSWORD, 0, 0);
};

// Memory management.
void __RPC_FAR * __RPC_API midl_user_allocate(size_t nBytes_) 
{ 
    return(malloc(nBytes_)); 
};

void __RPC_API midl_user_free(void __RPC_FAR * ptr_) 
{ 
    free(ptr_); 
};

