/*  Botik::Key Pro - Botik Key Client for Windows 9x/ME/NT/2000/XP/2003
 *  Copyright (C) 2004 Alexander V. Melnikoff
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public Licensse as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#ifndef __EVENTMSGS_H__
#define __EVENTMSGS_H__
// MessageIdTypedef=NTSTATUS
////////////////////////////////////////////////////////////////////////
// Multilingual message events.
//
// LanguageNames=(Russian=0x419:MSG00419)
//
// MessageId=0x1000
// Severity=Informational
// SymbolicName=ABK_MSG_INF_STARTING
// Language=English
// Here is message text
// .
// Language=Russian
//   
// .
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// The following are message definitions.
////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////
// Information messages.
////////////////////////////////////////////////////////////////////////
//
//  Values are 32 bit values layed out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//
#define STATUS_SEVERITY_WARNING          0x2
#define STATUS_SEVERITY_SUCCESS          0x0
#define STATUS_SEVERITY_INFORMATIONAL    0x1
#define STATUS_SEVERITY_ERROR            0x3


//
// MessageId: ABK_MSG_INF_STARTING
//
// MessageText:
//
//  Service Botik::Key Pro is starting...
//
#define ABK_MSG_INF_STARTING             ((DWORD)0x40001000L)

//
// MessageId: ABK_MSG_INF_RUNNING
//
// MessageText:
//
//  Service Botik::Key Pro is running with the following settings:
//  %1
//
#define ABK_MSG_INF_RUNNING              ((DWORD)0x40001001L)

//
// MessageId: ABK_MSG_INF_STOPPED
//
// MessageText:
//
//  Service Botik::Key Pro is stopped successfuly.
//
#define ABK_MSG_INF_STOPPED              ((DWORD)0x40001002L)

////////////////////////////////////////////////////////////////////////
// Error messages.
////////////////////////////////////////////////////////////////////////
//
// MessageId: ABK_MSG_ERR_START_SVC_CTRL_DISP
//
// MessageText:
//
//  StartServiceCtrlDispatcher failed due to the following error:
//  %1
//
#define ABK_MSG_ERR_START_SVC_CTRL_DISP  ((DWORD)0xC0002000L)

//
// MessageId: ABK_MSG_ERR_REG_SVC_CTRL_HANDLER
//
// MessageText:
//
//  RegisterServiceCtrlHandler failed due to the following error:
//  %1
//
#define ABK_MSG_ERR_REG_SVC_CTRL_HANDLER ((DWORD)0xC0002001L)

//
// MessageId: ABK_MSG_ERR_SVC_INIT
//
// MessageText:
//
//  Service initialization failed. Starting is terminated.
//
#define ABK_MSG_ERR_SVC_INIT             ((DWORD)0xC0002002L)

//
// MessageId: ABK_MSG_ERR_SVC_OPEN_CONFIG
//
// MessageText:
//
//  %1
//
#define ABK_MSG_ERR_SVC_OPEN_CONFIG      ((DWORD)0xC0002003L)

//
// MessageId: ABK_MSG_ERR_WINSOCK_INIT
//
// MessageText:
//
//  %1
//
#define ABK_MSG_ERR_WINSOCK_INIT         ((DWORD)0xC0002004L)

//
// MessageId: ABK_MSG_ERR_BKEY_SRV_ADDR
//
// MessageText:
//
//  %1
//
#define ABK_MSG_ERR_BKEY_SRV_ADDR        ((DWORD)0xC0002005L)

//
// MessageId: ABK_MSG_ERR_THREAD_EXEC
//
// MessageText:
//
//  %1
//
#define ABK_MSG_ERR_THREAD_EXEC          ((DWORD)0xC0002006L)

//
// MessageId: ABK_MSG_ERR_RPC
//
// MessageText:
//
//  RPC failed.
//  %1
//
#define ABK_MSG_ERR_RPC                  ((DWORD)0xC0002007L)

//
// MessageId: ABK_MSG_ERR_LOGFILE
//
// MessageText:
//
//  Open log file failed.
//  %1
//
#define ABK_MSG_ERR_LOGFILE              ((DWORD)0xC0002008L)

////////////////////////////////////////////////////////////////////////
// Warning messages.
////////////////////////////////////////////////////////////////////////
//
// MessageId: ABK_MSG_WRN_NO_KEY_IN_PLACE
//
// MessageText:
//
//  %1.
//
#define ABK_MSG_WRN_NO_KEY_IN_PLACE      ((DWORD)0x80003000L)

//
// MessageId: ABK_MSG_WRN_DEF_GATEWAY
//
// MessageText:
//
//  %1.
//
#define ABK_MSG_WRN_DEF_GATEWAY          ((DWORD)0x80003001L)

#endif	// __EVENTMSGS_H__